package model

// generated with yago. Better NOT to edit!

import (
	"database/sql"
	"fmt"
	"reflect"

	"github.com/slicebit/qb"

	"github.com/m4rw3r/uuid"
	"github.com/orus-io/yago"
)

const (
	// PipelineName is the Name field name
	PipelineName = "Name"
	// PipelineNameColumnName is the Name field associated column name
	PipelineNameColumnName = "name"
	// PipelineVersion is the Version field name
	PipelineVersion = "Version"
	// PipelineVersionColumnName is the Version field associated column name
	PipelineVersionColumnName = "version"
	// PipelineStatus is the Status field name
	PipelineStatus = "Status"
	// PipelineStatusColumnName is the Status field associated column name
	PipelineStatusColumnName = "status"
	// PipelineEdges is the Edges field name
	PipelineEdges = "Edges"
	// PipelineEdgesColumnName is the Edges field associated column name
	PipelineEdgesColumnName = "edges"
)

const (
	// PipelineTableName is the Pipeline associated table name
	PipelineTableName = "pipeline"
)

var pipelineTable = qb.Table(
	PipelineTableName,
	qb.Column(PipelineNameColumnName, qb.Varchar()).NotNull(),
	qb.Column(PipelineVersionColumnName, qb.Varchar()).NotNull(),
	qb.Column(PipelineStatusColumnName, qb.Varchar()).NotNull(),
	qb.Column(PipelineEdgesColumnName, qb.Text()).NotNull(),
	qb.Column(BaseIDColumnName, qb.UUID()).PrimaryKey().NotNull(),
	qb.Column(BaseCreatedAtColumnName, qb.Timestamp()).NotNull(),
	qb.Column(BaseUpdatedAtColumnName, qb.Timestamp()).Null(),
	qb.UniqueKey(
		PipelineNameColumnName,
		PipelineVersionColumnName,
	),
)

var pipelineType = reflect.TypeOf(Pipeline{})

// StructType returns the reflect.Type of the struct
// It is used for indexing mappers (and only that I guess, so
// it could be replaced with a unique identifier).
func (Pipeline) StructType() reflect.Type {
	return pipelineType
}

// PipelineModel provides direct access to helpers for Pipeline
// queries
type PipelineModel struct {
	mapper    *PipelineMapper
	Name      yago.ScalarField
	Version   yago.ScalarField
	Status    yago.MarshaledScalarField
	Edges     yago.ScalarField
	ID        yago.ScalarField
	CreatedAt yago.ScalarField
	UpdatedAt yago.ScalarField
}

// NewPipelineModel returns a new PipelineModel
func NewPipelineModel(meta *yago.Metadata) PipelineModel {
	mapper := NewPipelineMapper()
	meta.AddMapper(mapper)
	return PipelineModel{
		mapper:    mapper,
		Name:      yago.NewScalarField(mapper.Table().C(PipelineNameColumnName)),
		Version:   yago.NewScalarField(mapper.Table().C(PipelineVersionColumnName)),
		Status:    yago.NewMarshaledScalarField(mapper.Table().C(PipelineStatusColumnName)),
		Edges:     yago.NewScalarField(mapper.Table().C(PipelineEdgesColumnName)),
		ID:        yago.NewScalarField(mapper.Table().C(BaseIDColumnName)),
		CreatedAt: yago.NewScalarField(mapper.Table().C(BaseCreatedAtColumnName)),
		UpdatedAt: yago.NewScalarField(mapper.Table().C(BaseUpdatedAtColumnName)),
	}
}

// GetMapper returns the associated PipelineMapper instance
func (m PipelineModel) GetMapper() yago.Mapper {
	return m.mapper
}

// NewPipelineMapper initialize a NewPipelineMapper
func NewPipelineMapper() *PipelineMapper {
	m := &PipelineMapper{}
	return m
}

// PipelineMapper is the Pipeline mapper
type PipelineMapper struct{}

// GetMapper returns itself
func (mapper *PipelineMapper) GetMapper() yago.Mapper {
	return mapper
}

// Name returns the mapper name
func (*PipelineMapper) Name() string {
	return "model/Pipeline"
}

// Table returns the mapper table
func (*PipelineMapper) Table() *qb.TableElem {
	return &pipelineTable
}

// StructType returns the reflect.Type of the mapped structure
func (PipelineMapper) StructType() reflect.Type {
	return pipelineType
}

// SQLValues returns values as a map
// The primary key is included only if having non-default values
func (mapper PipelineMapper) SQLValues(instance yago.MappedStruct, fields ...string) map[string]interface{} {
	s, ok := instance.(*Pipeline)
	if !ok {
		panic(fmt.Sprintf(
			"Wrong struct type passed to the mapper. Expected &Pipeline{}, got %s",
			reflect.TypeOf(instance).Name(),
		))
	}
	allValues := len(fields) == 0
	m := make(map[string]interface{})
	if s.ID != (uuid.UUID{}) {
		m[BaseIDColumnName] = s.ID
	}
	if allValues || yago.StringListContains(fields, PipelineName) {
		m[PipelineNameColumnName] = s.Name
	}
	if allValues || yago.StringListContains(fields, PipelineVersion) {
		m[PipelineVersionColumnName] = s.Version
	}
	if allValues || yago.StringListContains(fields, PipelineStatus) {
		if b, err := s.Status.MarshalText(); err == nil {
			m[PipelineStatusColumnName] = b
		} else {
			panic(err)
		}
	}
	if allValues || yago.StringListContains(fields, PipelineEdges) {
		m[PipelineEdgesColumnName] = s.Edges
	}
	if allValues || yago.StringListContains(fields, BaseCreatedAt) {
		m[BaseCreatedAtColumnName] = s.CreatedAt
	}
	if allValues || yago.StringListContains(fields, BaseUpdatedAt) {
		m[BaseUpdatedAtColumnName] = s.UpdatedAt
	}
	return m
}

// FieldList returns the list of fields for a select
func (mapper PipelineMapper) FieldList() []qb.Clause {
	return []qb.Clause{
		pipelineTable.C(PipelineNameColumnName),
		pipelineTable.C(PipelineVersionColumnName),
		pipelineTable.C(PipelineStatusColumnName),
		pipelineTable.C(PipelineEdgesColumnName),
		pipelineTable.C(BaseIDColumnName),
		pipelineTable.C(BaseCreatedAtColumnName),
		pipelineTable.C(BaseUpdatedAtColumnName),
	}
}

// ScanPKey scans the primary key only
func (mapper PipelineMapper) ScanPKey(rows *sql.Rows, instance yago.MappedStruct) error {
	s, ok := instance.(*Pipeline)
	if !ok {
		panic(fmt.Sprintf(
			"Wrong struct type passed to the mapper. Expected &Pipeline{}, got %s",
			reflect.TypeOf(instance).Name(),
		))
	}
	return rows.Scan(
		&s.ID,
	)
}

// Scan a struct
func (mapper PipelineMapper) Scan(rows *sql.Rows, instance yago.MappedStruct) error {
	s, ok := instance.(*Pipeline)
	if !ok {
		panic(fmt.Sprintf(
			"Wrong struct type passed to the mapper. Expected &Pipeline{}, got %s",
			reflect.TypeOf(instance).Name(),
		))
	}
	var StatusText []byte
	if err := rows.Scan(
		&s.Name,
		&s.Version,
		&StatusText,
		&s.Edges,
		&s.ID,
		&s.CreatedAt,
		&s.UpdatedAt,
	); err != nil {
		return err
	}
	if err := s.Status.UnmarshalText(StatusText); err != nil {
		return err
	}
	return nil
}

// AutoIncrementPKey return true if a column of the pkey is autoincremented
func (PipelineMapper) AutoIncrementPKey() bool {
	return false
}

// LoadAutoIncrementPKeyValue set the pkey autoincremented column value
func (PipelineMapper) LoadAutoIncrementPKeyValue(instance yago.MappedStruct, value int64) {
	panic("Pipeline has no auto increment column in its pkey")
}

// PKey returns the instance primary key values
func (mapper PipelineMapper) PKey(instance yago.MappedStruct) (values []interface{}) {
	str := instance.(*Pipeline)
	values = append(values, str.ID)

	return
}

// PKeyClause returns a clause that matches the instance primary key
func (mapper PipelineMapper) PKeyClause(values []interface{}) qb.Clause {
	return pipelineTable.C(BaseIDColumnName).Eq(values[0])
}

const (
	// GraphNodeID is the ID field name
	GraphNodeID = "ID"
	// GraphNodeIDColumnName is the ID field associated column name
	GraphNodeIDColumnName = "id"
	// GraphNodePipelineID is the PipelineID field name
	GraphNodePipelineID = "PipelineID"
	// GraphNodePipelineIDColumnName is the PipelineID field associated column name
	GraphNodePipelineIDColumnName = "pipeline_id"
	// GraphNodeNodeID is the NodeID field name
	GraphNodeNodeID = "NodeID"
	// GraphNodeNodeIDColumnName is the NodeID field associated column name
	GraphNodeNodeIDColumnName = "node_id"
	// GraphNodeType is the Type field name
	GraphNodeType = "Type"
	// GraphNodeTypeColumnName is the Type field associated column name
	GraphNodeTypeColumnName = "type"
	// GraphNodeActorIDs is the ActorIDs field name
	GraphNodeActorIDs = "ActorIDs"
	// GraphNodeActorIDsColumnName is the ActorIDs field associated column name
	GraphNodeActorIDsColumnName = "actor_ids"
	// GraphNodeActors is the Actors field name
	GraphNodeActors = "Actors"
	// GraphNodeActorsColumnName is the Actors field associated column name
	GraphNodeActorsColumnName = "actors"
	// GraphNodeRoles is the Roles field name
	GraphNodeRoles = "Roles"
	// GraphNodeRolesColumnName is the Roles field associated column name
	GraphNodeRolesColumnName = "roles"
	// GraphNodeRoleBroadcast is the RoleBroadcast field name
	GraphNodeRoleBroadcast = "RoleBroadcast"
	// GraphNodeRoleBroadcastColumnName is the RoleBroadcast field associated column name
	GraphNodeRoleBroadcastColumnName = "role_broadcast"
	// GraphNodeSourceMatchEventTypes is the SourceMatchEventTypes field name
	GraphNodeSourceMatchEventTypes = "SourceMatchEventTypes"
	// GraphNodeSourceMatchEventTypesColumnName is the SourceMatchEventTypes field associated column name
	GraphNodeSourceMatchEventTypesColumnName = "source_match_event_types"
	// GraphNodeInputs is the Inputs field name
	GraphNodeInputs = "Inputs"
	// GraphNodeInputsColumnName is the Inputs field associated column name
	GraphNodeInputsColumnName = "inputs"
	// GraphNodeOutputs is the Outputs field name
	GraphNodeOutputs = "Outputs"
	// GraphNodeOutputsColumnName is the Outputs field associated column name
	GraphNodeOutputsColumnName = "outputs"
)

const (
	// GraphNodeTableName is the GraphNode associated table name
	GraphNodeTableName = "graph_node"
)

var graphNodeTable = qb.Table(
	GraphNodeTableName,
	qb.Column(GraphNodeIDColumnName, qb.BigInt()).PrimaryKey().AutoIncrement().NotNull(),
	qb.Column(GraphNodePipelineIDColumnName, qb.UUID()).NotNull(),
	qb.Column(GraphNodeNodeIDColumnName, qb.Varchar()).NotNull(),
	qb.Column(GraphNodeTypeColumnName, qb.Varchar()).NotNull(),
	qb.Column(GraphNodeActorIDsColumnName, qb.Varchar()).NotNull(),
	qb.Column(GraphNodeActorsColumnName, qb.Varchar()).NotNull(),
	qb.Column(GraphNodeRolesColumnName, qb.Varchar()).NotNull(),
	qb.Column(GraphNodeRoleBroadcastColumnName, qb.Boolean()).NotNull(),
	qb.Column(GraphNodeSourceMatchEventTypesColumnName, qb.Varchar()).NotNull(),
	qb.Column(GraphNodeInputsColumnName, qb.Text()).NotNull(),
	qb.Column(GraphNodeOutputsColumnName, qb.Text()).NotNull(),
	qb.UniqueKey(
		GraphNodePipelineIDColumnName,
		GraphNodeNodeIDColumnName,
	),
	qb.ForeignKey(GraphNodePipelineIDColumnName).References(PipelineTableName, BaseIDColumnName),
)

var graphNodeType = reflect.TypeOf(GraphNode{})

// StructType returns the reflect.Type of the struct
// It is used for indexing mappers (and only that I guess, so
// it could be replaced with a unique identifier).
func (GraphNode) StructType() reflect.Type {
	return graphNodeType
}

// GraphNodeModel provides direct access to helpers for GraphNode
// queries
type GraphNodeModel struct {
	mapper                *GraphNodeMapper
	ID                    yago.ScalarField
	PipelineID            yago.ScalarField
	NodeID                yago.ScalarField
	Type                  yago.ScalarField
	ActorIDs              yago.ScalarField
	Actors                yago.ScalarField
	Roles                 yago.ScalarField
	RoleBroadcast         yago.ScalarField
	SourceMatchEventTypes yago.ScalarField
	Inputs                yago.ScalarField
	Outputs               yago.ScalarField
}

// NewGraphNodeModel returns a new GraphNodeModel
func NewGraphNodeModel(meta *yago.Metadata) GraphNodeModel {
	mapper := NewGraphNodeMapper()
	meta.AddMapper(mapper)
	return GraphNodeModel{
		mapper:                mapper,
		ID:                    yago.NewScalarField(mapper.Table().C(GraphNodeIDColumnName)),
		PipelineID:            yago.NewScalarField(mapper.Table().C(GraphNodePipelineIDColumnName)),
		NodeID:                yago.NewScalarField(mapper.Table().C(GraphNodeNodeIDColumnName)),
		Type:                  yago.NewScalarField(mapper.Table().C(GraphNodeTypeColumnName)),
		ActorIDs:              yago.NewScalarField(mapper.Table().C(GraphNodeActorIDsColumnName)),
		Actors:                yago.NewScalarField(mapper.Table().C(GraphNodeActorsColumnName)),
		Roles:                 yago.NewScalarField(mapper.Table().C(GraphNodeRolesColumnName)),
		RoleBroadcast:         yago.NewScalarField(mapper.Table().C(GraphNodeRoleBroadcastColumnName)),
		SourceMatchEventTypes: yago.NewScalarField(mapper.Table().C(GraphNodeSourceMatchEventTypesColumnName)),
		Inputs:                yago.NewScalarField(mapper.Table().C(GraphNodeInputsColumnName)),
		Outputs:               yago.NewScalarField(mapper.Table().C(GraphNodeOutputsColumnName)),
	}
}

// GetMapper returns the associated GraphNodeMapper instance
func (m GraphNodeModel) GetMapper() yago.Mapper {
	return m.mapper
}

// NewGraphNodeMapper initialize a NewGraphNodeMapper
func NewGraphNodeMapper() *GraphNodeMapper {
	m := &GraphNodeMapper{}
	return m
}

// GraphNodeMapper is the GraphNode mapper
type GraphNodeMapper struct{}

// GetMapper returns itself
func (mapper *GraphNodeMapper) GetMapper() yago.Mapper {
	return mapper
}

// Name returns the mapper name
func (*GraphNodeMapper) Name() string {
	return "model/GraphNode"
}

// Table returns the mapper table
func (*GraphNodeMapper) Table() *qb.TableElem {
	return &graphNodeTable
}

// StructType returns the reflect.Type of the mapped structure
func (GraphNodeMapper) StructType() reflect.Type {
	return graphNodeType
}

// SQLValues returns values as a map
// The primary key is included only if having non-default values
func (mapper GraphNodeMapper) SQLValues(instance yago.MappedStruct, fields ...string) map[string]interface{} {
	s, ok := instance.(*GraphNode)
	if !ok {
		panic(fmt.Sprintf(
			"Wrong struct type passed to the mapper. Expected &GraphNode{}, got %s",
			reflect.TypeOf(instance).Name(),
		))
	}
	allValues := len(fields) == 0
	m := make(map[string]interface{})
	if s.ID != 0 {
		m[GraphNodeIDColumnName] = s.ID
	}
	if allValues || yago.StringListContains(fields, GraphNodePipelineID) {
		m[GraphNodePipelineIDColumnName] = s.PipelineID
	}
	if allValues || yago.StringListContains(fields, GraphNodeNodeID) {
		m[GraphNodeNodeIDColumnName] = s.NodeID
	}
	if allValues || yago.StringListContains(fields, GraphNodeType) {
		m[GraphNodeTypeColumnName] = s.Type
	}
	if allValues || yago.StringListContains(fields, GraphNodeActorIDs) {
		m[GraphNodeActorIDsColumnName] = s.ActorIDs
	}
	if allValues || yago.StringListContains(fields, GraphNodeActors) {
		m[GraphNodeActorsColumnName] = s.Actors
	}
	if allValues || yago.StringListContains(fields, GraphNodeRoles) {
		m[GraphNodeRolesColumnName] = s.Roles
	}
	if allValues || yago.StringListContains(fields, GraphNodeRoleBroadcast) {
		m[GraphNodeRoleBroadcastColumnName] = s.RoleBroadcast
	}
	if allValues || yago.StringListContains(fields, GraphNodeSourceMatchEventTypes) {
		m[GraphNodeSourceMatchEventTypesColumnName] = s.SourceMatchEventTypes
	}
	if allValues || yago.StringListContains(fields, GraphNodeInputs) {
		m[GraphNodeInputsColumnName] = s.Inputs
	}
	if allValues || yago.StringListContains(fields, GraphNodeOutputs) {
		m[GraphNodeOutputsColumnName] = s.Outputs
	}
	return m
}

// FieldList returns the list of fields for a select
func (mapper GraphNodeMapper) FieldList() []qb.Clause {
	return []qb.Clause{
		graphNodeTable.C(GraphNodeIDColumnName),
		graphNodeTable.C(GraphNodePipelineIDColumnName),
		graphNodeTable.C(GraphNodeNodeIDColumnName),
		graphNodeTable.C(GraphNodeTypeColumnName),
		graphNodeTable.C(GraphNodeActorIDsColumnName),
		graphNodeTable.C(GraphNodeActorsColumnName),
		graphNodeTable.C(GraphNodeRolesColumnName),
		graphNodeTable.C(GraphNodeRoleBroadcastColumnName),
		graphNodeTable.C(GraphNodeSourceMatchEventTypesColumnName),
		graphNodeTable.C(GraphNodeInputsColumnName),
		graphNodeTable.C(GraphNodeOutputsColumnName),
	}
}

// ScanPKey scans the primary key only
func (mapper GraphNodeMapper) ScanPKey(rows *sql.Rows, instance yago.MappedStruct) error {
	s, ok := instance.(*GraphNode)
	if !ok {
		panic(fmt.Sprintf(
			"Wrong struct type passed to the mapper. Expected &GraphNode{}, got %s",
			reflect.TypeOf(instance).Name(),
		))
	}
	return rows.Scan(
		&s.ID,
	)
}

// Scan a struct
func (mapper GraphNodeMapper) Scan(rows *sql.Rows, instance yago.MappedStruct) error {
	s, ok := instance.(*GraphNode)
	if !ok {
		panic(fmt.Sprintf(
			"Wrong struct type passed to the mapper. Expected &GraphNode{}, got %s",
			reflect.TypeOf(instance).Name(),
		))
	}
	if err := rows.Scan(
		&s.ID,
		&s.PipelineID,
		&s.NodeID,
		&s.Type,
		&s.ActorIDs,
		&s.Actors,
		&s.Roles,
		&s.RoleBroadcast,
		&s.SourceMatchEventTypes,
		&s.Inputs,
		&s.Outputs,
	); err != nil {
		return err
	}
	return nil
}

// AutoIncrementPKey return true if a column of the pkey is autoincremented
func (GraphNodeMapper) AutoIncrementPKey() bool {
	return true
}

// LoadAutoIncrementPKeyValue set the pkey autoincremented column value
func (GraphNodeMapper) LoadAutoIncrementPKeyValue(instance yago.MappedStruct, value int64) {
	s := instance.(*GraphNode)
	s.ID = value
}

// PKey returns the instance primary key values
func (mapper GraphNodeMapper) PKey(instance yago.MappedStruct) (values []interface{}) {
	str := instance.(*GraphNode)
	values = append(values, str.ID)

	return
}

// PKeyClause returns a clause that matches the instance primary key
func (mapper GraphNodeMapper) PKeyClause(values []interface{}) qb.Clause {
	return graphNodeTable.C(GraphNodeIDColumnName).Eq(values[0])
}
